diff --git a/lib/altsvc.c b/lib/altsvc.c
index a06f40bc2a..1c9128ff79 100644
--- a/lib/altsvc.c
+++ b/lib/altsvc.c
@@ -303,6 +303,8 @@ struct altsvcinfo *Curl_altsvc_init(void)
return NULL;
Curl_llist_init(&asi->list, NULL);
+ asi->used = FALSE;
+
/* set default behavior */
asi->flags = CURLALTSVC_H1
#ifdef USE_HTTP2
diff --git a/lib/altsvc.h b/lib/altsvc.h
index 831cd09743..6225a1c297 100644
--- a/lib/altsvc.h
+++ b/lib/altsvc.h
@@ -48,6 +48,8 @@ struct altsvcinfo {
char *filename;
struct Curl_llist list; /* list of entries */
long flags; /* the publicly set bitmask */
+
+ BIT(used);
};
const char *Curl_alpnid2str(enum alpnid id);
diff --git a/lib/url.c b/lib/url.c
index d111ef8119..f8d153864b 100644
--- a/lib/url.c
+++ b/lib/url.c
@@ -3427,7 +3427,6 @@ static void conn_meta_freeentry(void *p)
static CURLcode create_conn(struct Curl_easy *data,
struct connectdata **in_connect,
bool *reusedp,
- bool *async,
bool *use_slist)
{
CURLcode result = CURLE_OK;
@@ -3539,9 +3538,10 @@ static CURLcode create_conn(struct Curl_easy *data,
* Process the "connect to" linked list of hostname/port mappings.
* Do this after the remote port number has been fixed in the URL.
*************************************************************/
- if(*use_slist) {
- *use_slist = FALSE; /* next retry without slist */
+ if(!data->asi || !data->asi->used) {
result = parse_connect_to_slist(data, conn, data->set.connect_to);
+ if(data->asi)
+ data->asi->used = TRUE;
if(result)
goto out;
}
@@ -3856,11 +3856,13 @@ CURLcode Curl_connect(struct Curl_easy *data,
{
CURLcode result;
struct connectdata *conn;
-<<<<<<< HEAD
bool reused = FALSE;
-=======
bool use_slist = TRUE; /* start by attempting to use the slist */
->>>>>>> 3edfc1476 (first draft)
+
+#ifndef CURL_DISABLE_ALTSVC
+ if(data->asi)
+ data->asi->used = FALSE;
+#endif
*asyncp = FALSE; /* assume synchronous resolves by default */
*protocol_done = FALSE;
@@ -3869,32 +3871,33 @@ CURLcode Curl_connect(struct Curl_easy *data,
Curl_req_hard_reset(&data->req, data);
/* call the stuff that needs to be called */
-<<<<<<< HEAD
result = create_conn(data, &conn, &reused);
if(result == CURLE_NO_CONNECTION_AVAILABLE) {
DEBUGASSERT(!conn);
return result;
}
-=======
result = create_conn(data, &conn, asyncp, &use_slist);
#ifndef CURL_DISABLE_ALTSVC
/* if we failed because of the avc cache retry */
if(result && data-> asi
- && !use_slist
+ && data->asi->used
&& !(data-> asi-> flags & CURLALTSVC_NO_RETRY)
) {
+
+ infof(data, "Alt-Svc connection failed, retrying with original target");
+
+
if(conn && result != CURLE_NO_CONNECTION_AVAILABLE) {
Curl_detach_connection(data);
Curl_conn_terminate(data, conn, TRUE);
}
Curl_req_hard_reset(&data->req, data);
- result = create_conn(data, &conn, asyncp, &use_slist);
+ result = create_conn(data, &conn, asyncp);
}
#endif
->>>>>>> 3edfc1476 (first draft)
if(!result) {
DEBUGASSERT(conn);
diff --git a/tests/breaking_test b/tests/breaking_test
new file mode 100644
index 0000000000..a2b51b6106
--- /dev/null
+++ b/tests/breaking_test
@@ -0,0 +1,80 @@
+
+
+
+HTTP
+HTTP GET
+HTTP proxy
+
+
+
+#
+# Server-side
+
+
+
+HTTP/1.1 200 OK
+Unknown-header: blrub
+Content-Length: 6
+
+-foo-
+
+
+
+connection-monitor
+
+
+
+#
+# Client-side
+
+
+proxy
+alt-svc
+Debug
+
+
+# make debug-curl accept Alt-Svc over plain HTTP
+CURL_ALTSVC_HTTP="yeah"
+
+
+
+http
+
+
+
+alt-svc fail via proxy
+
+
+
+--proxy http://%HOSTIP:%HTTPPORT --alt-svc "%LOGDIR/altsvc-%TESTNUMBER" http://test.remote.haxx.se.%TESTNUMBER:8990
+
+
+h1 test.remote.haxx.se.%TESTNUMBER 8990 h1 %HOSTIP %NOLISTENPORT "20290222 22:19:28" 0 0
+
+
+
+proxy
+
+
+
+#
+# Verify data after the test has been "shot"
+
+
+HTTP/1.1 200 OK
+Unknown-header: blrub
+Content-Length: 6
+
+-foo-
+
+
+GET http://test.remote.haxx.se.%TESTNUMBER:8990/ HTTP/1.1
+Host: test.remote.haxx.se.%TESTNUMBER:8990
+User-Agent: curl/%VERSION
+Accept: */*
+Proxy-Connection: Keep-Alive
+
+[DISCONNECT]
+
+
+
diff --git a/tests/data/Makefile.am b/tests/data/Makefile.am
index 558c50cb3e..d8237773b7 100644
--- a/tests/data/Makefile.am
+++ b/tests/data/Makefile.am
@@ -279,8 +279,10 @@ test3100 test3101 test3102 test3103 test3104 test3105 \
\
test3200 test3201 test3202 test3203 test3204 test3205 test3207 test3208 \
test3209 test3210 test3211 test3212 test3213 test3214 test3215 \
-test4000 test4001
test3209 test3210 test3211 test3212 test3213 test3214 \
-test3300
+\
+test3300 test3301 test3302 test3303\
+\
+test4000 test4001
EXTRA_DIST = $(TESTCASES) DISABLED
diff --git a/tests/data/test3302 b/tests/data/test3302
new file mode 100644
index 0000000000..9b107c2a8b
--- /dev/null
+++ b/tests/data/test3302
@@ -0,0 +1,73 @@
+
+
+
+HTTP
+HTTP GET
+Alt-Svc
+
+
+
+#
+# Server-side
+
+
+HTTP/1.1 200 OK
+Unknown-header: blrub
+Content-Length: 6
+
+-foo-
+
+
+
+connection-monitor
+
+
+
+#
+# Client-side
+
+
+alt-svc
+Debug
+
+
+# make debug-curl accept Alt-Svc over plain HTTP
+CURL_ALTSVC_HTTP="yeah"
+
+
+
+http
+
+
+alt-svc fail connection
+
+
+
+--alt-svc "%LOGDIR/altsvc-%TESTNUMBER" http://%HOSTIP:%HTTPPORT/%TESTNUMBER
+
+
+h1 %HOSTIP %HTTPPORT h1 %HOSTIP %NOLISTENPORT "20290222 22:19:28" 0 0
+
+
+
+
+#
+# Verify data after the test has been "shot"
+
+
+HTTP/1.1 200 OK
+Unknown-header: blrub
+Content-Length: 6
+
+-foo-
+
+
+GET /%TESTNUMBER HTTP/1.1
+Host: %HOSTIP:%HTTPPORT
+User-Agent: curl/%VERSION
+Accept: */*
+
+[DISCONNECT]
+
+
+
diff --git a/tests/data/test3303 b/tests/data/test3303
new file mode 100644
index 0000000000..93667ed92b
--- /dev/null
+++ b/tests/data/test3303
@@ -0,0 +1,52 @@
+
+
+
+HTTP
+HTTP GET
+Alt-Svc
+NO_RETRY
+
+
+
+
+
+alt-svc
+Debug
+
+
+http
+
+
+alt-svc no-retry due to CURLALTSVC_NO_RETRY flag
+
+
+
+lib%TESTNUMBER
+
+
+
+http://%HOSTIP:%HTTPPORT/%TESTNUMBER
+
+
+
+h1 %HOSTIP %HTTPPORT h1 %HOSTIP %NOLISTENPORT "20290222 22:19:28" 0 0
+
+
+
+CURL_ALTSVC_HTTP="yeah"
+
+
+
+
+
+
+52
+
+
+
+
+
+
+
+
+
diff --git a/tests/libtest/Makefile.inc b/tests/libtest/Makefile.inc
index 40ec0d1559..84a8a00777 100644
--- a/tests/libtest/Makefile.inc
+++ b/tests/libtest/Makefile.inc
@@ -106,4 +106,5 @@ TESTS_C = \
lib2700.c \
lib3010.c lib3025.c lib3026.c lib3027.c lib3033.c lib3034.c \
lib3100.c lib3101.c lib3102.c lib3103.c lib3104.c lib3105.c \
- lib3207.c lib3208.c
+ lib3207.c lib3208.c \
+ lib3303.c
\ No newline at end of file
diff --git a/tests/libtest/lib3303 b/tests/libtest/lib3303
new file mode 100755
index 0000000000..77cbbac37f
--- /dev/null
+++ b/tests/libtest/lib3303
@@ -0,0 +1,210 @@
+#! /bin/bash
+
+# lib3303 - temporary wrapper script for .libs/lib3303
+# Generated by libtool (GNU libtool) 2.4.7 Debian-2.4.7-7build1
+#
+# The lib3303 program cannot be directly executed until all the libtool
+# libraries that it depends on are installed.
+#
+# This wrapper script should never be moved out of the build directory.
+# If it is, it will not operate correctly.
+
+# Sed substitution that helps us do robust quoting. It backslashifies
+# metacharacters that are still active within double-quoted strings.
+sed_quote_subst='s|\([`"$\\]\)|\\\1|g'
+
+# Be Bourne compatible
+if test -n "${ZSH_VERSION+set}" && (emulate sh) >/dev/null 2>&1; then
+ emulate sh
+ NULLCMD=:
+ # Zsh 3.x and 4.x performs word splitting on ${1+"$@"}, which
+ # is contrary to our usage. Disable this feature.
+ alias -g '${1+"$@"}'='"$@"'
+ setopt NO_GLOB_SUBST
+else
+ case `(set -o) 2>/dev/null` in *posix*) set -o posix;; esac
+fi
+BIN_SH=xpg4; export BIN_SH # for Tru64
+DUALCASE=1; export DUALCASE # for MKS sh
+
+# The HP-UX ksh and POSIX shell print the target directory to stdout
+# if CDPATH is set.
+(unset CDPATH) >/dev/null 2>&1 && unset CDPATH
+
+relink_command=""
+
+# This environment variable determines our operation mode.
+if test "$libtool_install_magic" = "%%%MAGIC variable%%%"; then
+ # install mode needs the following variables:
+ generated_by_libtool_version='2.4.7'
+ notinst_deplibs=' ../../lib/libcurl.la'
+else
+ # When we are sourced in execute mode, $file and $ECHO are already set.
+ if test "$libtool_execute_magic" != "%%%MAGIC variable%%%"; then
+ file="$0"
+
+# A function that is used when there is no print builtin or printf.
+func_fallback_echo ()
+{
+ eval 'cat <<_LTECHO_EOF
+$1
+_LTECHO_EOF'
+}
+ ECHO="printf %s\\n"
+ fi
+
+# Very basic option parsing. These options are (a) specific to
+# the libtool wrapper, (b) are identical between the wrapper
+# /script/ and the wrapper /executable/ that is used only on
+# windows platforms, and (c) all begin with the string --lt-
+# (application programs are unlikely to have options that match
+# this pattern).
+#
+# There are only two supported options: --lt-debug and
+# --lt-dump-script. There is, deliberately, no --lt-help.
+#
+# The first argument to this parsing function should be the
+# script's ../../libtool value, followed by no.
+lt_option_debug=
+func_parse_lt_options ()
+{
+ lt_script_arg0=$0
+ shift
+ for lt_opt
+ do
+ case "$lt_opt" in
+ --lt-debug) lt_option_debug=1 ;;
+ --lt-dump-script)
+ lt_dump_D=`$ECHO "X$lt_script_arg0" | /usr/bin/sed -e 's/^X//' -e 's%/[^/]*$%%'`
+ test "X$lt_dump_D" = "X$lt_script_arg0" && lt_dump_D=.
+ lt_dump_F=`$ECHO "X$lt_script_arg0" | /usr/bin/sed -e 's/^X//' -e 's%^.*/%%'`
+ cat "$lt_dump_D/$lt_dump_F"
+ exit 0
+ ;;
+ --lt-*)
+ $ECHO "Unrecognized --lt- option: '$lt_opt'" 1>&2
+ exit 1
+ ;;
+ esac
+ done
+
+ # Print the debug banner immediately:
+ if test -n "$lt_option_debug"; then
+ echo "lib3303:lib3303:$LINENO: libtool wrapper (GNU libtool) 2.4.7 Debian-2.4.7-7build1" 1>&2
+ fi
+}
+
+# Used when --lt-debug. Prints its arguments to stdout
+# (redirection is the responsibility of the caller)
+func_lt_dump_args ()
+{
+ lt_dump_args_N=1;
+ for lt_arg
+ do
+ $ECHO "lib3303:lib3303:$LINENO: newargv[$lt_dump_args_N]: $lt_arg"
+ lt_dump_args_N=`expr $lt_dump_args_N + 1`
+ done
+}
+
+# Core function for launching the target application
+func_exec_program_core ()
+{
+
+ if test -n "$lt_option_debug"; then
+ $ECHO "lib3303:lib3303:$LINENO: newargv[0]: $progdir/$program" 1>&2
+ func_lt_dump_args ${1+"$@"} 1>&2
+ fi
+ exec "$progdir/$program" ${1+"$@"}
+
+ $ECHO "$0: cannot exec $program $*" 1>&2
+ exit 1
+}
+
+# A function to encapsulate launching the target application
+# Strips options in the --lt-* namespace from $@ and
+# launches target application with the remaining arguments.
+func_exec_program ()
+{
+ case " $* " in
+ *\ --lt-*)
+ for lt_wr_arg
+ do
+ case $lt_wr_arg in
+ --lt-*) ;;
+ *) set x "$@" "$lt_wr_arg"; shift;;
+ esac
+ shift
+ done ;;
+ esac
+ func_exec_program_core ${1+"$@"}
+}
+
+ # Parse options
+ func_parse_lt_options "$0" ${1+"$@"}
+
+ # Find the directory that this script lives in.
+ thisdir=`$ECHO "$file" | /usr/bin/sed 's%/[^/]*$%%'`
+ test "x$thisdir" = "x$file" && thisdir=.
+
+ # Follow symbolic links until we get to the real thisdir.
+ file=`ls -ld "$file" | /usr/bin/sed -n 's/.*-> //p'`
+ while test -n "$file"; do
+ destdir=`$ECHO "$file" | /usr/bin/sed 's%/[^/]*$%%'`
+
+ # If there was a directory component, then change thisdir.
+ if test "x$destdir" != "x$file"; then
+ case "$destdir" in
+ [\\/]* | [A-Za-z]:[\\/]*) thisdir="$destdir" ;;
+ *) thisdir="$thisdir/$destdir" ;;
+ esac
+ fi
+
+ file=`$ECHO "$file" | /usr/bin/sed 's%^.*/%%'`
+ file=`ls -ld "$thisdir/$file" | /usr/bin/sed -n 's/.*-> //p'`
+ done
+
+ # Usually 'no', except on cygwin/mingw when embedded into
+ # the cwrapper.
+ WRAPPER_SCRIPT_BELONGS_IN_OBJDIR=no
+ if test "$WRAPPER_SCRIPT_BELONGS_IN_OBJDIR" = "yes"; then
+ # special case for '.'
+ if test "$thisdir" = "."; then
+ thisdir=`pwd`
+ fi
+ # remove .libs from thisdir
+ case "$thisdir" in
+ *[\\/].libs ) thisdir=`$ECHO "$thisdir" | /usr/bin/sed 's%[\\/][^\\/]*$%%'` ;;
+ .libs ) thisdir=. ;;
+ esac
+ fi
+
+ # Try to get the absolute directory name.
+ absdir=`cd "$thisdir" && pwd`
+ test -n "$absdir" && thisdir="$absdir"
+
+ program='lib3303'
+ progdir="$thisdir/.libs"
+
+
+ if test -f "$progdir/$program"; then
+ # Add our own library path to LD_LIBRARY_PATH
+ LD_LIBRARY_PATH="/home/user/Desktop/open_source_work/curl/lib/.libs:$LD_LIBRARY_PATH"
+
+ # Some systems cannot cope with colon-terminated LD_LIBRARY_PATH
+ # The second colon is a workaround for a bug in BeOS R4 sed
+ LD_LIBRARY_PATH=`$ECHO "$LD_LIBRARY_PATH" | /usr/bin/sed 's/::*$//'`
+
+ export LD_LIBRARY_PATH
+
+ if test "$libtool_execute_magic" != "%%%MAGIC variable%%%"; then
+ # Run the actual program with our arguments.
+ func_exec_program ${1+"$@"}
+ fi
+ else
+ # The program doesn't exist.
+ $ECHO "$0: error: '$progdir/$program' does not exist" 1>&2
+ $ECHO "This script is just a wrapper for $program." 1>&2
+ $ECHO "See the libtool documentation for more information." 1>&2
+ exit 1
+ fi
+fi
diff --git a/tests/libtest/lib3303.c b/tests/libtest/lib3303.c
new file mode 100644
index 0000000000..98058d0c4e
--- /dev/null
+++ b/tests/libtest/lib3303.c
@@ -0,0 +1,53 @@
+/***************************************************************************
+ * _ _ ____ _
+ * Project ___| | | | _ \| |
+ * / __| | | | |_) | |
+ * | (__| |_| | _ <| |___
+ * \___|\___/|_| \_\_____|
+ *
+ * Copyright (C) Daniel Stenberg, , et al.
+ *
+ * This software is licensed as described in the file COPYING, which
+ * you should have received as part of this distribution. The terms
+ * are also available at https://curl.se/docs/copyright.html.
+ *
+ * You may opt to use, copy, modify, merge, publish, distribute and/or sell
+ * copies of the Software, and permit persons to whom the Software is
+ * furnished to do so, under the terms of the COPYING file.
+ *
+ * This software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY
+ * KIND, either express or implied.
+ *
+ * SPDX-License-Identifier: curl
+ *
+ ***************************************************************************/
+
+/* testing the CURLALTSVC_NO_RETRY flag */
+
+#include "first.h"
+
+#include "memdebug.h"
+
+static CURLcode test_lib3303(char *URL)
+{
+ CURL *curl;
+ CURLcode res = CURLE_OK;
+ long flag = CURLALTSVC_NO_RETRY |
+ CURLALTSVC_H1 | CURLALTSVC_H2 | CURLALTSVC_H3;
+
+ global_init(CURL_GLOBAL_ALL);
+ easy_init(curl);
+
+ test_setopt(curl, CURLOPT_URL, URL);
+ test_setopt(curl, CURLOPT_ALTSVC, "log/altsvc-TESTNUMBER");
+ test_setopt(curl, CURLOPT_ALTSVC_CTRL, flag);
+ test_setopt(curl, CURLOPT_VERBOSE, 1L);
+
+ res = curl_easy_perform(curl);
+
+test_cleanup:
+ curl_easy_cleanup(curl);
+ curl_global_cleanup();
+
+ return res;
+}